/**
 * The following headder file defines the set of default colours used
 * by grouse and default colours and shapes
 */
#include <tulip/Color.h>
#include <qcolor.h>

#ifndef __COLOUR_SHAPE_DEFAULTS_H__
#define __COLOUR_SHAPE_DEFAULTS_H__

#define TULIP_WHITE (Color (255,255,255,255))
#define TULIP_BLACK (Color (0,0,0,255))	       
#define META_NODE_SHAPE (13) //meta nodes are hexagons
#define LEAF_NODE_SHAPE (1) //leaf nodes are squares
#define GLYPH_CENTRE_SHAPE (11) //centre of the glyph
#define META_NODE_BORDER_COLOUR (tlp::Color (0,0,0,255)) //border colour black
#define LEAF_NODE_BORDER_COLOUR (tlp::Color (0,0,0,255)) //border colour black
#define META_NODE_BORDER_WIDTH (2.0)
#define LEAF_NODE_BORDER_WIDTH (2.0)

//======================================================================
//defaults for node and edge alpha
#define NODE_ALPHA (255)
#define EDGE_ALPHA (80)

//These define colours to be used by topological features
#define TREE_COLOUR (tlp::Color (37, 89, 193, 255)) // blue
#define BICONNECTED_COLOUR (tlp::Color (157, 86, 74, 255)) //brown
#define UNKNOWN_COLOUR (tlp::Color (30, 171, 70, 255)) // green
#define EMBEDDER_COLOUR (tlp::Color (100, 87, 130, 255)) //purple
#define STRENGTH_COLOUR (tlp::Color (199, 197, 43, 255)) //gold
#define COMPLETE_COLOUR (tlp::Color (5, 199, 215, 255)) //teal
#define CONNECTED_COLOUR (tlp::Color (232, 151, 199, 255)) //pink
#define GLYPH_EDGE_COLOUR (tlp::Color (100, 87, 130, 255))

//These define the colours used by leaf nodes and edges
#define EDGE_COLOUR (tlp::Color (150,150,150,255)) //grey
#define LEAF_NODE_COLOUR (tlp::Color (120,120,120,255)) //grey

//This is the selection colour and line width
#define SELECTION_COLOUR (tlp::Color (223, 61, 51)) //red
#define SELECTED_BORDER_WIDTH (5.0) 

//This is the selection colour
#define PROCESSING_COLOUR (tlp::Color (250, 61, 51)) //red

//This the background colour
#define BACKGROUND_COLOUR (tlp::Color (255,255,255,255)) //white
#endif
