#include <qapplication.h>
#include <tulip/Graph.h>
#include <tulip/TlpTools.h>
#include <tulip/GlGraph.h>
#include <tulip/GlGraphWidget.h>
#include "GrouseInterfaceBackEnd.h"

int main(int argc, char **argv) {
  QApplication mainApp (argc,argv);

  /****************************************************/
  tlp::initTulipLib();
  tlp::loadPlugins();
  GlGraph::loadPlugins();
  
  /****************************************************/
  GrouseInterfaceBackEnd grouseMainWin;
  
  mainApp.setMainWidget(&grouseMainWin);
  grouseMainWin.resize(640,640);
  grouseMainWin.show();

  if (argc == 2) {
    Graph *cmdLineGraph = tlp::loadGraph(argv[1]);
    grouseMainWin.initInterface (cmdLineGraph);
  }//end if
  return mainApp.exec();
}
