#ifndef __GROUSE_SELECTION_PROPERTY__
#define __GROUSE_SELECTION_PROPERTY__
#include <vector>
#include <qobject.h>
#include <tulip/BooleanProperty.h>
#include <tulip/Graph.h>
#include <tulip/MutableContainer.h>
#include <tulip/GlGraphWidget.h>
#include "ColourShapeDefaults.h"
#include "MetaNodeBoundingCircle.h"
#include "OpenCloseHierarchy.h"

class GrouseSelectionProperty : public QObject {
  Q_OBJECT;
 public:
  GrouseSelectionProperty (tlp::Graph *displayGraph,
			   tlp::Graph *hierarchy,
			   OpenCloseHierarchy *openCloseHierarchy); 
  ~GrouseSelectionProperty();
  
  void clearSelection ();
  void setSelection (const std::vector<tlp::node> &nodes,
		     std::vector<GlABoundingCircle *> &augs,
		     bool emitSignal = true);

 signals:
  void selectionChanged (tlp::BooleanProperty &newSelection);

 private:
  tlp::Graph *displayGraph;
  tlp::BooleanProperty *selection;
  tlp::Graph *hierarchy;
  OpenCloseHierarchy *openCloseHierarchy;
  void selectNode (const tlp::node &curNode);
  void selectAug (GlABoundingCircle * aug);
 
};

#endif
