#include <vector>
#if (__GNUC__ < 3)
#  include <hash_map>
#else
#  include <ext/hash_map>
#endif
#include <tulip/Graph.h>
#include <tulip/StringProperty.h>
#include <tulip/ForEach.h>
#include "HierarchyMap.h"

using namespace std;
using namespace tlp;

//========================================================================
void genOriginalEdges (Graph *localGraph,
		       stdext::hash_map<edge, vector<edge> > &originalEdges) {
  //a proxy for the original edge attribute
  StringProperty *originalEdgesProxy = 
    localGraph->getProperty <StringProperty> (ORIGINAL_EDGE_NAME);
  
  //for all the edges at this level
  edge curEdge;
  forEach (curEdge, localGraph->getEdges()) {
    vector<edge> thisEdgeOrigEdge;

    //if there is a null string, there are no original edges
    //(we do not want to apply torques).
    if (originalEdgesProxy->getEdgeValue (curEdge) != "") {
      istringstream idparse (originalEdgesProxy->getEdgeValue (curEdge));
      unsigned int edgeid;
      while (!idparse.eof()) {
	idparse >> edgeid;
	thisEdgeOrigEdge.push_back (edge (edgeid));
      }//end while
    }//end if
    originalEdges[curEdge] = thisEdgeOrigEdge;
  }
}//end genOriginalEdges
