
#include <iostream>
#include "ColouredListViewItem.h"
#include "ColourShapeDefaults.h"
using namespace std;

//=======================================================================
QColor ColouredListViewItem::background(uint column) const {
  if (column < backgrounds.size())
    return backgrounds[column];
  return listView()->colorGroup().base();
}

//=======================================================================
void ColouredListViewItem::setBackground(uint column, const QColor &color)
{
  if (column >= backgrounds.size())
    backgrounds.resize(column + 1, listView()->colorGroup().base());
  backgrounds[column] = color;
}

//=======================================================================
void ColouredListViewItem::paintCell(QPainter *painter, const QColorGroup &cg,
				    int column, int width, int align)
{
  painter->save();
  QColorGroup grp(cg);
  if (column >= 0 && column < (int)backgrounds.size()) {
    if (this->isSelected ()) {
      QColor selColor(SELECTION_COLOUR.getR(), SELECTION_COLOUR.getG(),
		      SELECTION_COLOUR.getB());
      grp.setColor(QColorGroup::Highlight, selColor);
    }
    grp.setColor(QColorGroup::Base, backgrounds[column]);
  }
  QListViewItem::paintCell(painter, grp, column, width, align);
  painter->restore();
}

//=======================================================================
int ColouredListViewItem::width(const QFontMetrics &fm, 
			       const QListView *lv, int column) const
{
  int width;
  width = QListViewItem::width(fm, lv, column);
  return width;
}
