#include <qlistview.h>
#include <qvaluevector.h>
#include <qpainter.h>
#include <tulip/Node.h>

#ifndef __COLOURED_LIST_VIEW_ITEM__
#define __COLOURED_LIST_VIEW_ITEM__

/**
 * based on the following tutorial
 * http://doc.trolltech.com/qq/qq08-fancy-list-view.html#fancylistviewitems
 */
class ColouredListViewItem : public QListViewItem
{
 public:
  inline ColouredListViewItem(QListView *parent) : 
    QListViewItem(parent)
    {}
  
  inline ColouredListViewItem(QListViewItem *parent) : 
    QListViewItem(parent)
    {}
  
  void paintCell(QPainter *painter, const QColorGroup &cg,
		 int column, int width, int align);
  int width(const QFontMetrics &fm, const QListView *lv, int column) const;
  
  QColor background(uint column) const;
  void setBackground(uint column, const QColor &color);
  
 private:
  QValueVector<QColor> backgrounds;
};
#endif
