#if (QT_REL == 3)
#include <iostream>

#include <qstringlist.h>
#include <qwidgetplugin.h>
#include <tulip/Graph.h>
#include "MetaGraphHierarchyWidget.h"

#include "metahierarchywidget.xpm"

using namespace std;
using namespace tlp;

class QT_WIDGET_PLUGIN_EXPORT MetaGraphHierarchyPlugin : public QWidgetPlugin
{
public:
  MetaGraphHierarchyPlugin();
  ~MetaGraphHierarchyPlugin();
  
  QStringList keys() const;
  QWidget* create( const QString &classname, QWidget* parent = 0, const char* name = 0 );
  QString group( const QString& ) const;
  QIconSet iconSet( const QString& ) const;
  QString includeFile( const QString& ) const;
  QString toolTip( const QString& ) const;
  QString whatsThis( const QString& ) const;
  bool isContainer( const QString& ) const;
};

MetaGraphHierarchyPlugin::MetaGraphHierarchyPlugin() {}
MetaGraphHierarchyPlugin::~MetaGraphHierarchyPlugin() {}

QStringList MetaGraphHierarchyPlugin::keys() const {
  QStringList list;
  list << "MetaGraphHierarchyWidget";
  return list;
}

QWidget* MetaGraphHierarchyPlugin::create(const QString &key, QWidget* parent, const char* name) {
  if (key == "MetaGraphHierarchyWidget") 
    return new MetaGraphHierarchyWidget(parent, name, WStaticContents);
  return 0;
}

QString MetaGraphHierarchyPlugin::includeFile(const QString& feature) const {
  if (feature == "MetaGraphHierarchyWidget") 
    return "tulip/MetaGraphHierarchyWidget.h";
  return QString::null;
}

QString MetaGraphHierarchyPlugin::group(const QString& feature) const {
  if (feature == "MetaGraphHierarchyWidget")
    return "Tulip";
  return QString::null;
}

QIconSet MetaGraphHierarchyPlugin::iconSet(const QString& feature) const {
  if (feature == "MetaGraphHierarchyWidget") {
    return QIconSet(QPixmap (metahierarchywidget_xpm));
  }
  return QIconSet();
}

QString MetaGraphHierarchyPlugin::toolTip(const QString& feature) const {
  if (feature == "MetaGraphHierarchyWidget") 
    return tr("Meta Graph Hierarchy Widget");
  return QString::null;
}

QString MetaGraphHierarchyPlugin::whatsThis(const QString& feature) const {
  if (feature == "MetaGraphHierarchyWidget") 
    return tr("A widget to display a treeview of a specified metagraph hierarchy.");
  return QString::null;
}

bool MetaGraphHierarchyPlugin::isContainer(const QString& feature) const {
  if (feature == "MetaGraphHierarchyWidget") return false;
  return false;
}

Q_EXPORT_PLUGIN(MetaGraphHierarchyPlugin);

#endif
