#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <tulip/LayoutProperty.h>
#include "tulip/GlGraph.h"
using namespace std;
namespace tlp {

  //===================================================================
  const GlGraphRenderingParameters& GlGraph::getRenderingParameters() {
    return _renderingParameters;
  }
  //===================================================================
  void GlGraph::setRenderingParameters(const GlGraphRenderingParameters &parameter) {
    if (_graph != 0) _graph->removeObserver(this);
    drawState = tlp::DRAWEND;
    deleteIterators();
    bool alreadyInOrderedMode = _renderingParameters.isElementOrdered();

    _renderingParameters = parameter;

    if (_graph != _renderingParameters.getGraph()) { //the graph changed
      _graph = _renderingParameters.getGraph();
      nbElementsFrame.setAll(500); //reinit number of elements drawn by frame   
      if (_graph !=0 && _renderingParameters.isElementOrdered()) {
	buildOrderedList();
      }
    }
    else { //same graph
      if (_renderingParameters.isElementOrdered() != alreadyInOrderedMode) {
	buildOrderedList();
      }
    }
    if (_renderingParameters.isElementOrdered() && _graph!=0)
      _graph->addObserver(this);
  }
}
