#ifndef SELECTIONWIDGET_H
#define SELECTIONWIDGET_H

#include <tulip/tulipconf.h>
#include <tulip/Node.h>
#include <tulip/Edge.h>

#if (QT_REL == 4)
#include "tulip/Qt3ForTulip.h"
#endif

#include "tulip/FindSelectionData.h"

namespace tlp {

class Graph;
class PropertyInterface;
class BooleanProperty;

class TLP_QT_SCOPE SelectionWidget : FindSelection {
  Q_OBJECT
    public:
  SelectionWidget(Graph *graph, QWidget *parent = 0, const char *name = 0,
		  Qt::WFlags fl = 0);
  int exec();

 private:
  Graph *graph;
  void insertProperties();
  int getOperation();
  int getSource();
  int getMode();
  void evalNodes(PropertyInterface *, int, std::string, int, BooleanProperty *);
  void evalEdges(PropertyInterface *, int, std::string, int, BooleanProperty *);

  virtual void propertyChanged( int no );
  PropertyInterface *getProperty();
  void find(BooleanProperty *);
  
  protected slots:
    virtual void accept();
};

}
#endif //SELECTIONWIDGET_H
