//-*-c++-*-
/*
 Author: Sophie BARDET & Alexandre BURNETT
 Email : sophie.bardet@gmail.com, aburnett397@gmail.com
 Last modification : 14/05/2005
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by  
 the Free Software Foundation; either version 2 of the License, or     
 (at your option) any later version.
*/

//============================================================
void tlp::GraphDecorator::clear(){
  graph_component->clear();
}

//============================================================
tlp::Graph *tlp::GraphDecorator::addSubGraph(tlp::BooleanProperty *selection){
  return graph_component->addSubGraph(selection);
}

//============================================================
void tlp::GraphDecorator::delSubGraph(tlp::Graph * s){
  graph_component->delSubGraph(s);
}

//============================================================
void tlp::GraphDecorator::delAllSubGraphs(tlp::Graph *s){
  graph_component->delAllSubGraphs(s);
}

//============================================================
tlp::Graph* tlp::GraphDecorator::getSuperGraph()const{
  return graph_component->getSuperGraph();
}

//============================================================
void tlp::GraphDecorator::setSuperGraph(tlp::Graph* s){
  graph_component->setSuperGraph(s);
}

//============================================================
tlp::Graph* tlp::GraphDecorator::getRoot() const{
  return graph_component->getRoot();
}

//============================================================
tlp::Iterator<tlp::Graph *> * tlp::GraphDecorator::getSubGraphs() const{
  return graph_component->getSubGraphs();
}

//============================================================
tlp::node tlp::GraphDecorator::source(const tlp::edge e)const{
  return graph_component->source(e);
}

//============================================================
tlp::node tlp::GraphDecorator::target(const tlp::edge e)const {
  return graph_component->target(e);
}

//============================================================
tlp::node tlp::GraphDecorator::opposite(const tlp::edge e, const tlp::node n)const {
  return graph_component->opposite(e,n);
}

//============================================================
tlp::edge tlp::GraphDecorator::existEdge(const tlp::node n, const tlp::node m)const {
  return graph_component->existEdge(n,m);
}

//============================================================
void tlp::GraphDecorator::reverse(const tlp::edge e){
  graph_component->reverse(e);
}

//============================================================
unsigned int tlp::GraphDecorator::deg(const tlp::node n)const {
  return graph_component->deg(n);
}

//============================================================
unsigned int tlp::GraphDecorator::indeg(const tlp::node n)const {
  return graph_component->indeg(n);
}

//============================================================
unsigned int tlp::GraphDecorator::outdeg(const tlp::node n)const {
  return graph_component->outdeg(n);
}

//============================================================
tlp::node tlp::GraphDecorator::getOneNode() const{
  return graph_component->getOneNode();
}

//============================================================
tlp::node tlp::GraphDecorator::getInNode(const tlp::node n,unsigned int i)const{
  return graph_component->getInNode(n,i);
}

//============================================================
tlp::node tlp::GraphDecorator::getOutNode(const tlp::node n,unsigned int i) const{
  return graph_component->getOutNode(n,i);
}

tlp::edge tlp::GraphDecorator::getOneEdge() const{
  return graph_component->getOneEdge();
}

//============================================================
unsigned int tlp::GraphDecorator::numberOfNodes()const{
  return graph_component->numberOfNodes();
}

//============================================================
unsigned int tlp::GraphDecorator::numberOfEdges()const{
  return graph_component->numberOfEdges();
}

//============================================================
bool tlp::GraphDecorator::isElement(const tlp::node n) const{
  return graph_component->isElement(n);
}

//============================================================
bool tlp::GraphDecorator::isElement(const tlp::edge e) const{
  return graph_component->isElement(e);
}

//============================================================
tlp::node tlp::GraphDecorator::addNode(){
  return graph_component->addNode();
}

//============================================================
void tlp::GraphDecorator::addNode(const tlp::node n){
  graph_component->addNode(n);
}

//============================================================
tlp::edge tlp::GraphDecorator::addEdge(const tlp::node n, const tlp::node n2){
  return graph_component->addEdge(n, n2);
}

//============================================================
void tlp::GraphDecorator::addEdge(const tlp::edge e){
  graph_component->addEdge(e);
}

//============================================================
void tlp::GraphDecorator::delNode(const tlp::node n){
  graph_component->delNode(n);
}

//============================================================ 
void tlp::GraphDecorator::delAllNode(const tlp::node n){
  graph_component->delAllNode(n);
}

//============================================================
void tlp::GraphDecorator::delEdge(const tlp::edge e){
  graph_component->delEdge(e);
}

//============================================================
void tlp::GraphDecorator::delAllEdge(const tlp::edge e){
  graph_component->delAllEdge(e);
}

//============================================================
void tlp::GraphDecorator::setEdgeOrder(const tlp::node n,const std::vector<tlp::edge> & s){
  graph_component->setEdgeOrder(n,s);
}

void tlp::GraphDecorator::swapEdgeOrder(const tlp::node n ,const tlp::edge e1, const tlp::edge e2){
  graph_component->swapEdgeOrder(n, e1, e2);
} 

//============================================================
tlp::Iterator<tlp::node>* tlp::GraphDecorator::getNodes() const {
  return graph_component->getNodes();
}

//============================================================
tlp::Iterator<tlp::node>* tlp::GraphDecorator::getInNodes(const tlp::node n) const {
  return graph_component->getInNodes(n);
}

//============================================================
tlp::Iterator<tlp::node>* tlp::GraphDecorator::getOutNodes(const tlp::node n) const {
  return graph_component->getOutNodes(n);
}

//============================================================
tlp::Iterator<tlp::node>* tlp::GraphDecorator::getInOutNodes(const tlp::node n) const {
  return graph_component->getInOutNodes(n);
}

//============================================================
tlp::Iterator<tlp::edge>* tlp::GraphDecorator::getEdges() const {
  return graph_component->getEdges();
}

//============================================================
tlp::Iterator<tlp::edge>* tlp::GraphDecorator::getOutEdges(const tlp::node n) const {
  return graph_component->getOutEdges(n);
}

//============================================================
tlp::Iterator<tlp::edge>* tlp::GraphDecorator::getInOutEdges(const tlp::node n) const {
  return graph_component->getInOutEdges(n);
}

//============================================================
tlp::Iterator<tlp::edge>* tlp::GraphDecorator::getInEdges(const tlp::node n) const {
  return graph_component->getInEdges(n);
}

//============================================================
tlp::DataSet & tlp::GraphDecorator::getAttributes(){
  return graph_component->getAttributes();
}

//============================================================
tlp::PropertyInterface* tlp::GraphDecorator::getProperty(const std::string &name){
  return graph_component->getProperty(name);
}

//============================================================ 
bool tlp::GraphDecorator::existProperty(const std::string&name){
  return graph_component->existProperty(name);
}

//============================================================
bool tlp::GraphDecorator::existLocalProperty(const std::string&name){
  return graph_component->existLocalProperty(name) ;
}

//============================================================
void tlp::GraphDecorator::delLocalProperty(const std::string&name){
  return graph_component->delLocalProperty(name);
}

//============================================================
void tlp::GraphDecorator::addLocalProperty(const std::string &name, tlp::PropertyInterface *prop) {
  graph_component->addLocalProperty(name, prop);
}

//============================================================
tlp::Iterator<std::string>* tlp::GraphDecorator::getLocalProperties(){
  return graph_component->getLocalProperties();
}

//============================================================
tlp::Iterator<std::string>* tlp::GraphDecorator::getInheritedProperties(){
  return graph_component->getInheritedProperties();
}

//============================================================
tlp::Iterator<std::string>* tlp::GraphDecorator::getProperties(){
  return graph_component->getProperties();
}
