//-*-c++-*-
/**
 Author: David Auber
 Email : auber@labri.fr
 Last modification : 20/08/2001
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by  
 the Free Software Foundation; either version 2 of the License, or     
 (at your option) any later version.
*/
#ifndef TOOLBAR_H
#define TOOLBAR_H
#include "ToolBarData.h"
#include <vector>

namespace tlp {
class GWInteractor;
}

using namespace std;

class ToolBar : public ToolBarData
{ 
  Q_OBJECT;

public:
  ToolBar( QWidget* parent = 0, const char* name = 0, Qt::WFlags fl = 0 );
  ~ToolBar();
  
  vector<tlp::GWInteractor *> &getCurrentInteractors() const;

public slots:
  void setSelect();
  void setSelectInteractor(tlp::GWInteractor *);
  void setAddEdge();
  void setAddNode();
  void setDelete();
  void setZoomBox();
  void setMoveSelection();
  void setSelection();
  void setMagicSelection();
  void setGraphNavigate();

signals:
void interactorsChanged(const std::vector<tlp::GWInteractor *> &);
  
private:
  vector<tlp::GWInteractor *> *currentInteractors;
  void setCurrentInteractors(vector<tlp::GWInteractor *> *interactors);
  void deleteInteractors(vector<tlp::GWInteractor *> &interactors);
};

#endif // TOOLBAR_H
