#include <tulip/Graph.h>
#include <tulip/GlGraphWidget.h>
#include <tulip/StringProperty.h>
#include "ElementInfoToolTip.h"

using namespace tlp;


ElementInfoToolTip::ElementInfoToolTip(QWidget* parent,const char* name,GlGraphWidget *glWidget) :
  QToolTip(parent),
  glWidget(glWidget) {
}

void ElementInfoToolTip::maybeTip( const QPoint & p ) {
  node tmpNode;
  edge tmpEdge;
  ElementType type;
  QString tmp;
  if (glWidget->doSelect(p.x(), p.y(), type, tmpNode, tmpEdge)) {
    // try to show the viewlabel if any
    StringProperty *labels = glWidget->getGraph()->getProperty<StringProperty>("viewLabel");
    std::string label;
    QString ttip;
    switch(type) {
    case NODE:
      label = labels->getNodeValue(tmpNode);
      if (!label.empty())
	ttip += (label + " (").c_str();
      ttip += QString("node: ")+ tmp.setNum(tmpNode.id);
      if (!label.empty())
	ttip += ")";
      tip(QRect(p.x()-2,p.y()-2,4,4), ttip); 
      break;
    case EDGE: 
      label = labels->getEdgeValue(tmpEdge);
      if (!label.empty())
	ttip += (label + "(").c_str();
      ttip += QString("edge: ")+ tmp.setNum(tmpEdge.id);
      if (!label.empty())
	ttip += ")";
      tip(QRect(p.x()-2,p.y()-2,4,4), ttip);
      break;
    }
  }
}
